'use strict';

exports.__esModule = true;
exports.compose = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; // import { compose } from './util'


var _util = require('./util');

var _styles = require('./styles');

var styles = _interopRequireWildcard(_styles);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

// from recompose
var cx = function cx() {
  for (var _len = arguments.length, funcs = Array(_len), _key = 0; _key < _len; _key++) {
    funcs[_key] = arguments[_key];
  }

  return funcs.reduce(function (a, b) {
    return function () {
      return a(b.apply(undefined, arguments));
    };
  }, function (arg) {
    return arg;
  });
};
// space({ theme, p: 2, color: 'tomato' })
// { padding: '8px' }
// color({ padding: '8px', ...rest })
//

var compose = exports.compose = function compose() {
  for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    args[_key2] = arguments[_key2];
  }

  var funcs = args.filter(Boolean).filter(function (fn) {
    return typeof fn === 'function';
  });
  return function (props) {
    var style = {};
    for (var i = 0; i < funcs.length; i++) {
      var func = funcs[i];
      style = (0, _util.merge)(style, func(props));
    }

    return style;
  };
  /*
  const fn = props => funcs
    .map(fn => fn(props))
    .filter(Boolean)
    .reduce(merge, {})
  fn.propTypes = funcs
  .map(fn => fn.propTypes)
  .reduce(merge, {})
  return fn
  */
};

var dict = Object.keys(styles).map(function (key) {
  return {
    key: key,
    propNames: Object.keys(styles[key].propTypes || {})
  };
}).reduce(function (acc, b) {
  var vals = b.propNames.reduce(function (a, name) {
    var _extends2;

    return _extends({}, a, (_extends2 = {}, _extends2[name] = b.key, _extends2));
  }, {});
  return _extends({}, acc, vals);
}, {});

var funcs = Object.keys(styles).map(function (key) {
  return styles[key];
}).filter(function (func) {
  return typeof func === 'function';
});
var all = compose.apply(undefined, funcs);

/*
  // API

  const style = system({
    px: 3,
    width: 1/2,
    color: 'tomato'
  })
  // { paddingLeft: '16px', paddingRight: '16px', width: '50%', color: 'tomato' }
*/

exports.default = all;